
#INCLUDE "FiveWin.ch"

STATIC oWnd
STATIC lOpen := .T.

*-- FUNCTION -----------------------------------------------------------------
* Name........: Start
* Beschreibung:
* Argumente...: None
* Rckgabewert: .T.
* Author......: Timm Sodtalbers
*-----------------------------------------------------------------------------
FUNCTION Start()

   LOCAL oBmp, aFont[2], aSay[2], oIcon

   SET DELETED ON
   SET CONFIRM ON
   SET 3DLOOK ON
   SET MULTIPLE OFF
   SET DATE FORMAT TO "dd.mm.yyyy"
   SET EPOCH TO 1960

   //File-Handles erhhen
   SetHandleCount(100)

   SET RESOURCES TO "EXAMPLE.DLL"

   SETKEY( VK_F1, {|| OpenHtmlHelp() } )

   DEFINE FONT aFont[1] NAME "ARIAL" SIZE 0,-14
   DEFINE FONT aFont[2] NAME "ARIAL" SIZE 0,-14

   DEFINE ICON oIcon NAME "ICON1"

   DEFINE WINDOW oWnd FROM 2, 3 TO 28, 85 ;
      TITLE "EasyDialog - Example application" ;
      ICON oIcon ;
      COLOR RGB( 255, 255, 255 ), RGB( 255, 255, 255 )

   @  50, 50 BUTTON "Open Example Dialog" OF oWnd SIZE 200, 40 FONT aFont[1] PIXEL ;
      ACTION ( OpenDialog(), ;
               IIF( lOpen, ( MsgInfo( "Open the dialog again to see that your" + CRLF + ;
                             "position and size changes were saved." ), lOpen := .F. ), ) )

   @ 100, 50 BUTTON "Developer Help File" OF oWnd SIZE 200, 40 FONT aFont[1] PIXEL ;
      ACTION OpenHtmlHelp()

   @ 150, 50 BUTTON "Exit" OF oWnd SIZE 200, 40 FONT aFont[1] PIXEL ACTION oWnd:End()

   @ 130, 300 SAY aSay[1] PROMPT 'What does "Powered by EasyDialog" mean?' ;
      OF oWnd SIZE 400, 20 COLOR RGB( 0, 25, 25 ) PIXEL FONT aFont[2]

   @ 160, 320 SAY aSay[2] PROMPT ;
      "All dialogs build from resource are resizable and movable."    + CRLF + CRLF + ;
      "The controls are adjusted automatically like the developer"    + CRLF + ;
      "has predefined."                                               + CRLF + CRLF + ;
      "The positions and sizes of the dialogs and their controls are" + CRLF + ;
      "stored. In a network environment each client can have its own" + CRLF + ;
      "dialog settings."                                              + CRLF + CRLF + ;
      "Browser cells adjust automatically on resizing. If the user"   + CRLF + ;
      "resizes a cell the new width will be stored."                  + CRLF + CRLF + ;
      "Automatical adjustment to the screen resolution."              + CRLF + CRLF + ;
      "The dialogs can be designed directly in the application."      + CRLF + CRLF + ;
      "EasyDialog works with only one additional line of code for"    + CRLF + ;
      "each dialog."    ;
      OF oWnd SIZE 500, 290 COLOR RGB( 0, 100, 100 ) PIXEL FONT aFont[2]

   SET MESSAGE OF oWnd TO "by Timm Sodtalbers - www.reportdesigner.info" ;
      CENTERED KEYBOARD DATE

   ACTIVATE WINDOW oWnd MAXIMIZED ;
      ON INIT ( ShowLogo(), ;
                ED_AdjustToRes( ".\EasyDialogExample.ini", ;
                                "The dialogs will be adjusted to the current resolution." ) )

   AEVAL( aFont, {|x| x:End() } )
   SET RESOURCES TO

RETURN (.T.)


*-- FUNCTION -----------------------------------------------------------------
* Name........: ShowLogo
* Beschreibung:
* Argumente...: None
* Rckgabewert: .T.
* Author......: Timm Sodtalbers
*-----------------------------------------------------------------------------
FUNCTION ShowLogo()

   LOCAL oBmp

   @ oWnd:nBottom - 100, oWnd:nRight - 250 ;
      BITMAP oBmp RESOURCE "LOGO" OF oWnd NOBORDER PIXEL

RETURN (.T.)


* - FUNCTION ---------------------------------------------------------------
*  Function....: OpenDialog
*  Beschreibung:
*  Argumente...: None
*  Rckgabewert: (Nil)
*  Author......: Timm Sodtalbers
* --------------------------------------------------------------------------
FUNCTION OpenDialog()

   LOCAL oDlg, oBrw, oFld, aFont[2], aDlg, aResName
   LOCAL aGet     := { "Powered by EasyDialog!", SPACE(10), SPACE(10), SPACE(10), SPACE(10) }
   LOCAL cCode    := MEMOREAD( ".\example.prg" )
   LOCAL lCheck   := .T.
   LOCAL nRadio   := 1
   LOCAL cText    := CRLF + "   >>>  Resize and move the dialog!  <<<"
   LOCAL cED_File := ".\EasyDialogExample.ini"

   DEFINE FONT aFont[1] NAME "FIXEDSYS"   SIZE 0,-8
   DEFINE FONT aFont[2] NAME GetSysFont() SIZE 0,-14

   DEFINE DIALOG oDlg RESOURCE "MainDialog"

   REDEFINE BUTTON ID 101 OF oDlg ACTION oDlg:End()
   REDEFINE BUTTON ID 102 OF oDlg
   REDEFINE BUTTON ID 103 OF oDlg
   REDEFINE BUTTON ID 104 OF oDlg
   REDEFINE BUTTON ID 105 OF oDlg

   REDEFINE BITMAP ID 501 RESOURCE "ARROW2" OF oDlg TRANSPAREN

   REDEFINE SAY ID 171 PROMPT " Open the system menu to design the dialog." OF oDlg ;
      FONT aFont[2] COLOR RGB( 255, 255, 255 ), RGB( 0, 128, 128 )

   REDEFINE CHECKBOX lCheck ID 181 OF oDlg

   REDEFINE FOLDER oFld ID 110 OF oDlg ;
      PROMPT " Informationen ", " Browser Test ", " Example Source Code ", ;
             " Special Get Style " ;
      DIALOGS "FolderDialog1", "FolderDialog2", "FolderDialog3", "FolderDialog4"

   REDEFINE SAY ID 171 PROMPT "Say1:" OF oFld:aDialogs[1]
   REDEFINE SAY ID 172 PROMPT "Say2:" OF oFld:aDialogs[1]
   REDEFINE SAY ID 173 PROMPT "Say3:" OF oFld:aDialogs[1]
   REDEFINE SAY ID 174 PROMPT "Say4:" OF oFld:aDialogs[1]

   REDEFINE GET aGet[1] ID 301 OF oFld:aDialogs[1]
   REDEFINE GET aGet[2] ID 302 OF oFld:aDialogs[1]
   REDEFINE GET aGet[3] ID 303 OF oFld:aDialogs[1]
   REDEFINE GET aGet[4] ID 304 OF oFld:aDialogs[1]

   REDEFINE BITMAP ID 401 RESOURCE "LOGO" OF oFld:aDialogs[1]

   REDEFINE GET cText ID 101 OF oFld:aDialogs[1] MEMO FONT aFont[2]

   REDEFINE RADIO nRadio ID 121, 122 OF oFld:aDialogs[1]

   REDEFINE GROUP ID 131 OF oFld:aDialogs[1]

   REDEFINE GROUP ID 201 OF oFld:aDialogs[1]
   REDEFINE GROUP ID 202 OF oFld:aDialogs[1]
   REDEFINE GROUP ID 203 OF oFld:aDialogs[1]

   USE EXAMPLE

   REDEFINE LISTBOX oBrw ;
      FIELDS EXAMPLE->FIRST, EXAMPLE->LAST, EXAMPLE->STREET, EXAMPLE->CITY ;
      FIELDSIZES 100, 100, 120, 120 ;
      ID 401 OF oFld:aDialogs[2]

   REDEFINE GET cCode ID 101 OF oFld:aDialogs[3] MEMO FONT aFont[1]

   //Folder 4
   REDEFINE SAY ID 171 PROMPT "Say1:" OF oFld:aDialogs[4]
   REDEFINE SAY ID 172 PROMPT "Say2:" OF oFld:aDialogs[4]
   REDEFINE SAY ID 173 PROMPT "Say3:" OF oFld:aDialogs[4]
   REDEFINE SAY ID 174 PROMPT "Say4:" OF oFld:aDialogs[4]

   REDEFINE GET aGet[1] ID 301 OF oFld:aDialogs[4]
   REDEFINE GET aGet[2] ID 302 OF oFld:aDialogs[4]
   REDEFINE GET aGet[3] ID 303 OF oFld:aDialogs[4]
   REDEFINE GET aGet[4] ID 304 OF oFld:aDialogs[4]

   aDlg := { oDlg, oFld:aDialogs[1], oFld:aDialogs[2], oFld:aDialogs[3], oFld:aDialogs[4] }

   /*
   Use aResName if you have one resource for various dialogs. With aResName
   you can give a resource a unique name.

   Example: You have a resource called "Dialog1" and you want to use it twice
            but resizing one dialog should not change the size of the other dialog.

      DEFINE DIALOG oDlg RESOURCE "Dialog1"
      ...
      ACTIVATE DIALOG oDlg ON INIT ED_Use( oDlg, cED_File,, { "UniqueName1" } )

      DEFINE DIALOG oDlg RESOURCE "Dialog1"
      ...
      ACTIVATE DIALOG oDlg ON INIT ED_Use( oDlg, cED_File,, { "UniqueName2" } )
   */

   //If you want to show the controls with a special style use this for example:
   oFld:aDialogs[4]:bPainted := {|| ED_OnPaint( oFld:aDialogs[4], ;
                                    {|oCtrl,oDlg| SetGetStyle( oCtrl, oDlg ) } ) }

   ACTIVATE DIALOG oDlg ;
      ON INIT ED_Use( aDlg, cED_File ) /*,, aResName )*/ ;
      VALID   ED_ResizeDlg( { oFld:aDialogs[2] } )

   /*
   Calling ED_ResizeDlg on the VALID clause stores the widths of the
   browser cells when the cells are resized but not the dialog.

   If you need the datas :bResized and :bMoved also for other purposes:

   oDlg:bResized := {|| ED_ResizeDlg( aDlg ) }
   oDlg:bMoved   := {|| ED_MoveDlg( aDlg ) }

   ACTIVATE DIALOG oDlg ;
      ON INIT ( ED_SetDlg( aDlg, cED_File ), ;
                ED_Add2SysMenu( aDlg ) )
   */

   EXAMPLE->(DBCLOSEAREA())

   AEVAL( aFont, {|x| x:End() } )

RETURN NIL


*-- FUNCTION -----------------------------------------------------------------
* Name........: SetGetStyle
* Beschreibung:
* Argumente...: None
* Rckgabewert: NIL
* Author......: Timm Sodtalbers
*-----------------------------------------------------------------------------
FUNCTION SetGetStyle( oCtrl, oDlg )

   LOCAL hBrush, hOldBrush

   IF AT( "TGET", UPPER( oCtrl:ClassName() ) ) <> 0

      hBrush     := CreateSolidBrush( RGB( 255, 255, 255 ) )
      hOldBrush  := SelectObject( oDlg:hDC, hBrush )

      Rectangle( oDlg:hDC, oCtrl:nTop - 2, oCtrl:nLeft - 2, ;
                           oCtrl:nTop + oCtrl:nHeight + 1, oCtrl:nLeft + oCtrl:nWidth + 1 )

      SelectObject( oDlg:hDC, hOldBrush )
      DeleteObject( hBrush )

   ENDIF

RETURN (.T.)


*-- FUNCTION -----------------------------------------------------------------
* Name........: OpenHtmlHelp
* Beschreibung:
* Argumente...: None
* Rckgabewert: .T.
* Author......: Timm Sodtalbers
*-----------------------------------------------------------------------------
FUNCTION OpenHtmlHelp( cTopicID, nTopicNr, cHelpFile )

   LOCAL cPara := ""

   DEFAULT cHelpFile := ".\help\easydlg.chm"

   IF nTopicNr <> NIL
      cPara := "-mapid " + ALLTRIM(STR( nTopicNr, 10 )) + ;
               " " + ALLTRIM( cHelpFile )
   ELSEIF cTopicID <> NIL
      cPara := '"' + ALLTRIM( cHelpFile ) + "::/" + ;
               ALLTRIM( cTopicID ) + '"'
   ELSE
      cPara := '"' + ALLTRIM( cHelpFile ) + '"'
   ENDIF

   ShellExecute( 0, "Open", "HH.exe", ALLTRIM( cPara ), NIL, 1 )

RETURN (.T.)


*-- FUNCTION -----------------------------------------------------------------
* Name........: GetSysFont
* Beschreibung:
* Argumente...: None
* Rckgabewert: .T.
* Author......: Timm Sodtalbers
*-----------------------------------------------------------------------------
FUNCTION GetSysFont()

RETURN "Ms Sans Serif"